import dbus
import time
import sys

#grab the dbus Banshee object. It exposes the current track.
bus = dbus.SessionBus()
banshee = bus.get_object("org.bansheeproject.Banshee", "/org/bansheeproject/Banshee/PlayerEngine")
iface = dbus.Interface(banshee, dbus_interface='org.bansheeproject.Banshee.PlayerEngine')

last_sent = ''
while True:
  #get the current track
  curr_track = iface.GetCurrentTrack()
  title = ''
  artist = ''
  #grab the information form the track if it exists
  if curr_track.has_key("name"):
    title = curr_track["name"]
  if curr_track.has_key("artist"):
    artist = curr_track["artist"]

  #format the data correctly in case we don't have the title or the artist
  to_send = ''
  if title == '' or artist == '':
    to_send = title + artist
  else:
    to_send = title + " by " + artist

  #check if you already sent this track, if so do not send again
  if last_sent != to_send:
    #print the data to stdout
    print to_send
    sys.stdout.flush()
    last_sent = to_send
  else:
    time.sleep(1)
